import math
import numpy

class BetaLawCAK(object) :
    def set_pars(self, vterm, beta, RStar) :
        self._vterm = vterm
        self._beta = beta
        self._RStar = RStar

    def get_yvals(self, r_sph_arr) :
        return self.get_vr_arr(r_sph_arr)

    def get_vr_arr(self, r_sph_arr) :
        numPoints = len(r_sph_arr)

        velo = numpy.array(range(numPoints), dtype='f')

        for ix in range(numPoints) :
            velo[ix] = self.get_vr(r_sph_arr[ix])

        return velo

    def get_vr(self, r_sph) :

        v_r = self._vterm*pow(1-0.9983*self._RStar/r_sph,self._beta);

        return v_r
