import math
import numpy

class ParkerIso(object) :
    def set_pars(self, rcrit, csound) :
        self.RCrit = rcrit
        self.cs = csound

    def get_yvals(self, r_sph_arr) :
        return self.get_vr_arr(r_sph_arr)

    def get_vr_arr(self, r_sph_arr) :
        numPoints = len(r_sph_arr)

        velo = numpy.array(range(numPoints), dtype='f')

        for ix in range(numPoints) :
            velo[ix] = self.get_vr(r_sph_arr[ix])

        return velo

    def get_vr(self, r_sph) :

        r_norm = r_sph/self.RCrit

        rhs = 4.*(math.log(r_norm) + 1./r_norm) - 3.;

        v_r = 0

        if(r_norm < 1.) :
            v_r = 1.e-9
        else :
            v_r = 1.1

        diff = 1.
        #        for iNum in range(100) :
        iter = 0
        while (diff > 1.e-8 and iter < 100) :
            v_new = v_r - ( (math.log(v_r**2.) -
                             v_r**2. + rhs)/((2.0/v_r) - 2.*v_r) )
            diff = abs( (v_r - v_new)/v_r )
            v_r = v_new
            iter = iter+1

        print " iters: " + str(iter) + " "+ str(diff)
        return v_r*self.cs
