#include "constants.H"

#if (PARTICLE_TRANSPORT == CRONOS_ON)
#include "DummyEmissionProcess.H"

DummyEmission::DummyEmission(
		normalisation * normHD,
		normalisation * normParticle,
		REAL differentialEmissivity
	):
	EmissionField(normHD,normParticle)
{
	this->differentialEmissivity = differentialEmissivity;
}


DummyEmission::~DummyEmission(
	)
{
}

REAL DummyEmission::get_photonEmissivity_LAB(
		Data & gdata,
		int ix, int iy, int iz,
		const REAL photonEnergy_LAB,
		const REAL photonDirection_LAB[3]
)
{
	return differentialEmissivity;
}


DummyEmissionProcess::DummyEmissionProcess(
			normalisation * normHD,
			normalisation * normParticle,
			Quantity differentialEmissivity
		):
		RadiativeLossProcess(normHD,normParticle)
{
	REAL differentialEmissivity_num = normHD->get_num(normHD->DIFF_NUM_EMISS, differentialEmissivity);
	dummyEmission = new DummyEmission(normHD, normParticle, differentialEmissivity_num);
	this->emissionField = dummyEmission;
}

DummyEmissionProcess::~DummyEmissionProcess()
{
	delete dummyEmission;
}

void DummyEmissionProcess::get_momentumLoss(
		REAL momentum,
		REAL & loss
)
{
}


std::string DummyEmissionProcess::get_type(
) const
{
	return "DummyEmission";
}

#endif