#ifndef CRONOS_MINMOD_H
#define CRONOS_MINMOD_H = 1
#include <iostream>

#include "limiter.H"

using namespace std;

class minmod: public limiter_func {
public:
	minmod() {
		name = "minmod";
		Theta = value((char*)"Theta");
	}
	virtual REAL compute(REAL &, REAL &, REAL &);
private:
	REAL Theta;
};

inline REAL minmod::compute(REAL &up, REAL &uc, REAL &um)
{
	up *= Theta;
	um *= Theta;
	if(up*um > 0.) {
		if(up > 0){
			return std::min(up,(std::min(uc,um)));
		} else if(up < 0){
			return std::max(up,(std::max(uc,um)));
		} else {
			cerr << " Error " << endl;
			exit(1);
		}
	} else {
		return 0.;
	}
}


#endif
