#ifndef DUMMY_BOUNDARY_HANDLER
#define DUMMY_BOUNDARY_HANDLER

#include <vector>
#include "matrix.H"

#include "Grid1D.H"
#include <functional>

class BoundaryHandler1D {
public:
	BoundaryHandler1D(int lowerBoundaryType, int upperBoundaryType);

	// bc for momentum space
	void do_BCsCellAve(NumMatrix<double,1> &, const Grid1D &, std::function<double(double)> & advectionFunction) const;
	void do_BCsSecond(NumMatrix<double,1> &, const Grid1D &, std::function<double(double)> & advectionFunction) const;
	int get_bcType(int dir) const;

private:
	std::vector<int> bcType;

	void bcPeriodic(NumMatrix<double,1> &, const Grid1D &, int top) const;
	void bcZero(NumMatrix<double,1> &, const Grid1D &, int top) const;
	void bcLinearExtrapolation(NumMatrix<double,1> &, const Grid1D &, int top) const;
	void bcLinearExtrapolationOutflow(NumMatrix<double,1> &, const Grid1D &, std::function<double(double)> & advectionFunction, int top) const;
	void bcLogExtrapolation(NumMatrix<double,1> &, const Grid1D &, int top) const;

	void bcSecondPeriodic(NumMatrix<double,1> &, const Grid1D &, int top) const;
	void bcSecondZero(NumMatrix<double,1> &, const Grid1D &, int top) const;
	void bcSecondLinearExtrapolation(NumMatrix<double,1> &, const Grid1D &, int top) const;
	void bcSecondLinearExtrapolationOutflow(NumMatrix<double,1> &, const Grid1D &, std::function<double(double)> & advectionFunction, int top) const;
	void bcSecondLogExtrapolation(NumMatrix<double,1> &, const Grid1D &, int top) const;
};





#endif
