#include "EmissionField.H"

#if (PARTICLE_TRANSPORT == CRONOS_ON)

EmissionField::EmissionField(
		normalisation * normHD,
		normalisation * normParticle
	)
{
	this->normHD = normHD;
	this->normParticle = normParticle;
}

EmissionField::~EmissionField(
		)
{
}

REAL EmissionField::get_photonEmissivity_LAB(
		Data & gdata,
		int ix, int iy, int iz,
		const REAL photonEnergy_LAB,
		const REAL photonDirection_LAB[3]
	)
{
	throw CException(" Not Implemented ", __PRETTY_FUNCTION__);
}

REAL EmissionField::get_photonEmissivity_COM(
		Data & gdata,
		int ix, int iy, int iz,
		const REAL photonEnergy_COM,
		const REAL photonDirection_COM[3]
	)
{
	throw CException(" Not Implemented ", __PRETTY_FUNCTION__);
}


EmissionField_COM::EmissionField_COM(
		normalisation * normHD,
		normalisation * normParticle
		)
	: EmissionField(normHD, normParticle)
{
}

EmissionField_COM::~EmissionField_COM(
		)
{
}

REAL EmissionField_COM::get_photonEmissivity_LAB(
		Data & gdata,
		int ix, int iy, int iz,
		const REAL energy_LAB,
		const REAL photonDirection_LAB[3]
	)
{
	REAL photonEnergy_COM;
	REAL photonDirection_COM[3];
	lorentzTrafo.set_boostVector(
			gdata.om[gdata.fluid.get_q_sx()](ix,iy,iz),
			gdata.om[gdata.fluid.get_q_sy()](ix,iy,iz),
			gdata.om[gdata.fluid.get_q_sz()](ix,iy,iz),
			gdata.lorentz(ix, iy, iz)
			);
	lorentzTrafo.nullLike_temporal1(energy_LAB, photonDirection_LAB, photonEnergy_COM);
	lorentzTrafo.nullLike_direction1(photonDirection_LAB, photonDirection_COM);

	REAL photonEmissivity_COM = get_photonEmissivity_COM(gdata, ix, iy, iz, photonEnergy_COM, photonDirection_COM);

	lorentzTrafo.set_boostVector(
			gdata.om[gdata.fluid.get_q_sx()](ix,iy,iz),
			gdata.om[gdata.fluid.get_q_sy()](ix,iy,iz),
			gdata.om[gdata.fluid.get_q_sz()](ix,iy,iz),
			gdata.lorentz(ix, iy, iz),
			true
			);
	REAL photonEmissivity_LAB;
	lorentzTrafo.nullLike_temporal1(photonEmissivity_COM, photonDirection_COM, photonEmissivity_LAB);

	return photonEmissivity_LAB;
}

#endif


