#ifndef CRONOS_LORENTZ_H
#define CRONOS_LORENTZ_H

#ifdef MODULE_TEST
#define REAL double
#else
#include "constants.H"
#endif

#include "util.H"
#include <cmath>
#include <cassert>

class LorentzTrafo {
public:
	LorentzTrafo(
		);

	~LorentzTrafo(
		);

	// four velocity
	void set_boostVector(
			const REAL uboost[3],
			bool invert = false
			);

	void set_boostVector(
			REAL uboostx,
			REAL uboosty,
			REAL uboostz,
			bool invert = false
			);

	void set_boostVector(
			const REAL uboost[3],
			const REAL lorentz,
			bool invert = false
			);

	void set_boostVector(
			REAL uboostx,
			REAL uboosty,
			REAL uboostz,
			const REAL lorentz,
			bool invert = false
			);

	REAL get_matrixElement(
			int row,
			int col
			) const;

	// Null Like trafos
	void nullLike_direction1(
			const REAL inDir[3],
			REAL outDir[3]
			) const;

	void nullLike_temporal1(
			const REAL inEnergy,
			const REAL inDir[3],
			REAL & outEnergy
			) const;

	void nullLike_temporal1_iso(
			const REAL inEnergy,
			REAL & outEnergy
	) const;

	void nullLike_temporal2(
			const REAL inEnergy,
			const REAL inDir[3],
			REAL & outEnergy
			) const;

	void nullLike_temporal2_iso(
			const REAL inEnergy,
			REAL & outEnergy
	) const;

	REAL get_dopplerFactor(
			const REAL dir[3]
			) const;

	REAL get_dopplerFactor_inv(
			const REAL dir[3]
			) const;
protected:
	REAL uboost[3];
	REAL lorentz;

private:
	int __ix, __iy, __iz;
	REAL __dir[3];

};



#endif
