#ifndef CRONOS_LOSS_PROCESS_H
#define CRONOS_LOSS_PROCESS_H

#include <cmath>
#include "data.H"
#include "constants.H"
#include "Particle.H"
#include "normalisation.H"

#include <string>

class LossProcess {
public:
	LossProcess(
			normalisation * normHD,
			normalisation * normParticle
		);

	virtual ~LossProcess(
		);

	virtual void set_particle(
			Particle & particle
			);

	virtual void compute_constants(
			Data & gdata,
			int ix, int iy, int iz
		);

	virtual void get_momentumLoss(
			REAL momentum,
			REAL & loss
		) = 0;

	virtual std::string get_type(
		) const = 0;

	virtual REAL get_momentumLoss_c1_int(
			REAL momentum
		);

	virtual REAL get_momentumLoss_c2(
			REAL momentum
		);

protected:
	normalisation * normHD;
	normalisation * normParticle;

	Particle * particle;
};

#endif
