#ifndef CRONOS_MAGNETIC_FIELD_SPECIAL_H
#define CRONOS_MAGNETIC_FIELD_SPECIAL_H

#include "RadiationField.H"
#include "MagneticField.H"

using namespace CRONOS_CONSTANTS;

class ConstantMagneticField: public MagneticField_idealMHD_LAB {
public:
	ConstantMagneticField(
			normalisation * normHD,
			Quantity _magneticFieldStrength,
			REAL _magneticFieldAxis[3]
		):
		MagneticField_idealMHD_LAB(normHD)
	{
		magneticFieldStrength = _magneticFieldStrength;
		magneticFieldStrength_num = normHD->get_num(magneticFieldStrength);

		REAL dirNorm = 0;
		for (int iDir = 0; iDir < 3; ++iDir) {
			magneticFieldAxis[iDir] = _magneticFieldAxis[iDir];
			dirNorm += sqr(magneticFieldAxis[iDir]);
		}

		dirNorm = sqrt(dirNorm);
		for (int iDir = 0; iDir < 3; ++iDir) {
			magneticFieldAxis[iDir] /= dirNorm;
		}
	}

	virtual	~ConstantMagneticField(
		)
	{
	}

	// All arguments in COM Frame
	REAL get_magneticFieldStrength_LAB(
			Data & gdata,
			int ix, int iy, int iz
		) override
	{
		return magneticFieldStrength_num;
	}

	void get_magneticFieldDir_LAB(
			Data & gdata,
			int ix, int iy, int iz,
			REAL magneticFieldDir_LAB[3]
		) override
	{
		for (int iDir = 0; iDir < 3; ++iDir) {
			magneticFieldDir_LAB[iDir] = magneticFieldAxis[iDir];
		}
	}

protected:
	Quantity magneticFieldStrength;
	REAL magneticFieldStrength_num;
	REAL magneticFieldAxis[3];

};



#endif
