#ifndef CRONOS_RADIATIVE_LOSS_PROCESS_H
#define CRONOS_RADIATIVE_LOSS_PROCESS_H

#include "LossProcess.H"
#include "EmissionField.H"

class RadiativeLossProcess: public LossProcess {
public:
	RadiativeLossProcess(
			normalisation * normHD,
			normalisation * normParticle
		);

	virtual ~RadiativeLossProcess(
		);

	virtual void compute_constants(
			Data & gdata,
			int ix, int iy, int iz
		);

	virtual void get_momentumLoss(
			REAL momentum,
			REAL & loss
		) = 0;

	virtual std::string get_type(
	) const = 0;

	EmissionField & get_emissionField(
			);

protected:
	EmissionField * emissionField;
};



#endif
