#include "LorentzTrafo.H"
#include <iostream>

using namespace std;

#ifndef REAL
#define REAL double
#endif


int main() {
	LorentzTrafo lorentzTrafo;

	REAL uboost[3] = {1.,0.,0.};

	lorentzTrafo.set_boostVector(uboost);

	REAL dir1[3] = {0.,1.,0};
	REAL energy1 = 1.;

	REAL dir2[3];
	REAL energy2;

	lorentzTrafo.nullLike_temporal1(energy1, dir1, energy2);
	lorentzTrafo.nullLike_direction1(dir1, dir2);

	cout << energy2 << " | " << dir2[0] << " " << dir2[1] << " " << dir2[2] << endl;

	REAL dir3[3];
	REAL energy3;

	lorentzTrafo.set_boostVector(uboost, true);

	lorentzTrafo.nullLike_temporal1(energy2, dir2, energy3);
	lorentzTrafo.nullLike_direction1(dir2, dir3);

	cout << energy3 << " | " << dir3[0] << " " << dir3[1] << " " << dir3[2] << endl;


	// ----------------------------------------------------------
	// Metrics
	bool failed = false;

	cout << " Direction Trafo Length...";
	REAL length2 = sqrt(sqr(dir2[0]) + sqr(dir2[1]) + sqr(dir2[2]));

	if (length2 - 1. > 1e-7) {
		failed = true;
		cout << "\t Failed -> " << length2 << endl;
	} else {
		cout << "\t passed!" << endl;
	}


	cout << " Energy Back Trafo...";
	REAL energyErr = abs(energy1 - energy3) / energy1;

	if (energyErr > 1e-7) {
		failed = true;
		cout << "\t\t Failed -> " << energyErr << endl;
	} else {
		cout << "\t\t passed!" << endl;
	}


	cout << " Direction Back Trafo ...";
	REAL dirErr = abs(dir1[0] - dir3[0]) + abs(dir1[1] - dir3[1]) + abs(dir1[2] - dir3[2]);

	if (dirErr > 1e-7) {
		failed = true;
		 cout << "\t Failed -> " << dirErr << endl;
	} else {
		cout << "\t passed!" << endl;
	}



	if (failed) {
		return 1.;
	} else {
		return 0;
	}
}
