#include "Functions.H"
#include <limits>

template <typename T>
Function<T>::Function()
{
	x = std::numeric_limits<T>::min();
}

template <typename T>
T Function<T>::get_value(
		T x
	)
{
	set_x(x);
	return _get_value();
}

template <typename T>
T Function<T>::operator()(
		T x
)
{
	set_x(x);
	return _get_value();
}

template <typename T>
T Function<T>::get_value(
	)
{
	return _get_value();
}

template <typename T>
T Function<T>::operator()(
)
{
	return _get_value();
}

template <typename T>
void Function<T>::set_x(
		T x
	)
{
	if (this->x != x)
	{
		new_x();
	}
	this->x = x;
}


template <typename T>
ReziprocalFunction<T>::ReziprocalFunction(
		)
{
	this->function = 0;
}

template <typename T>
ReziprocalFunction<T>::ReziprocalFunction(
		Function<T> * function
		)
{
	assert(function != 0);
	this->function = function;
}

template <typename T>
void ReziprocalFunction<T>::set_function(
		Function<T> * function
		)
{
	assert(function != 0);
	this->function = function;
}

template <typename T>
void ReziprocalFunction<T>::set_x(
		T x
	)
{
	this->x = x;
	function->set_x(x);
}

template <typename T>
T ReziprocalFunction<T>::_get_value()
{
	return 1. / function->get_value();
}


// ---------------------------------------------
// Precompilations

template class Function<float>;
template class Function<double>;

template class ReziprocalFunction<float>;
template class ReziprocalFunction<double>;
