#ifndef CRONOS_FUNCTIONS_H
#define CRONOS_FUNCTIONS_H

#include <cassert>

template <typename T>
class Function {
public:
	Function();
	virtual ~Function() {};
	T get_value(T x);
	T get_value();
	T operator()();
	T operator()(T x);
	virtual void set_x(T x);
	virtual void new_x() {};

protected:
	T x;
	virtual T _get_value() = 0;
};


template <typename T>
class ReziprocalFunction: public Function<T> {
public:
	ReziprocalFunction();
	ReziprocalFunction(Function<T> * function);
	virtual ~ReziprocalFunction() {};
	virtual void set_function(Function<T> * function);
	virtual void set_x(T x);

protected:
	T _get_value();
	Function<T> * function;
};




#endif

