#include "integration.H"
#include "Functions.H"
#include <cmath>
#include <iostream>


template <typename T>
class powInt: public Function<T> {
public:
	void set_p(T p) {this->p = p;};

protected:
	T p;
	T _get_value() {return std::pow(this->x, p);}
};


template <typename T>
class sineInt: public Function<T> {
protected:
	T _get_value() {return std::sin(this->x);}
};


int main() {

	TrapezoidRule<double> TR;
	AdaptiveSubdivisionIntegration<double> AS(& TR);
	double a;
	double b;
	double tol;


	powInt<double> f;
	f.set_p(4.);

	a = 0.;
	b = 1.;
	tol = 1e-4 / (b - a);

	std::cout << TR.integrate(&f, a, b) << std::endl;
	std::cout << AS.integrate(&f, a, b, tol) << std::endl;
	std::cout << AS.integrate(&f, a, b, f.get_value(a), f.get_value(b), tol) << std::endl;

	std::cout << " ---------------------- " << std::endl;

	sineInt<double> g;

	a = 0.;
	b = M_PI;
	tol = 1e-4 / (b - a);

	std::cout << TR.integrate(&g, a, b) << std::endl;
	std::cout << AS.integrate(&g, a, b, tol) << std::endl;
	std::cout << AS.integrate(&g, a, b, g.get_value(a), g.get_value(b), tol) << std::endl;



}
