#ifndef STATE_H
#define STATE_H

#ifndef REAL
#define REAL double
#endif

#include <iostream>

class primState {
public:
	REAL rho;
	REAL ux;
	REAL uy;
	REAL uz;
	REAL Etherm;
#if(CRSWITCH_DUAL_ENERGY == CRONOS_ON)
	REAL specific_entropy;
#endif

  REAL computeLorentz() const;
  bool isNan() const;
  bool isOk() const;
};


class consState {
public:
	REAL density;
	REAL momentum_x;
	REAL momentum_y;
	REAL momentum_z;
	REAL tau;
#if(CRSWITCH_DUAL_ENERGY == CRONOS_ON)
	REAL sigma;
#endif

  bool isNan() const;
  bool isOk() const;
};


std::ostream & operator<<(std::ostream & os, const primState& prim);
std::ostream & operator<<(std::ostream & os, const consState& cons);

consState computeCons(const primState & prim, const ProblemType & Problem);
#endif