#include "data.H"
#include "gridgen.H"
#include "mod_Emission_Test.H"
#include "mod_AbsorptionTest.H"
#include "mod_InverseComptonTest.H"
#include "problem.H"


void Environment::setType(Data &gdata) {
	int type = static_cast<int>(value((char*)"type"));

	if (type == 1) {
		Problem = new RHD_Emission_Test(gdata);
	} else
	if (type == 2) {
		Problem = new AbsorptionTest(gdata);
	} else 
	if (type == 3) {
		Problem = new InverseComptonTest(gdata);
	} else {
		cerr << "   Unknown problem type " << type << " -- exiting " << endl;
		exit(-22);
	}

	Problem->init_problem(gdata);
	Problem->set_InfoData(gdata);
}



#if (NON_LINEAR_GRID == CRONOS_ON)
void Grid::set_UserGridFunction(int dir) {
	myNonlinGrid[dir] = new GridFunction_Sin();
  // myNonlinGrid[dir] = new GridFunction_Lin();

}
#endif
