import sys

from CronosPyLib.ProjHandler import ProjHandler
import os
import numpy as np

from astropy.constants import c
import astropy.units as u
import naima
from naima.models import Synchrotron, PowerLaw, InverseCompton

from matplotlib.colors import LogNorm
from matplotlib import cm

import matplotlib.pyplot as plt

from cxlib.matplotlib_utils import savefigMultipage
import copy



def get_absorption(distance):
	rootDir = os.getcwd()
	proj = ProjHandler(os.path.join(rootDir, 'BlackbodyExtended%i' % distance))
	emissionData = proj.emissionData[0]
	emission = emissionData.emissions[0]
	energies = emission.energies
	spectrum = emission.reductions[0]
  
	if len(energies) != 1:
		raise "Somethings fishy"

	return spectrum["DummyEmission_Absorption"][0]/spectrum["DummyEmission"][0]
	#sky.getFlux("DummyEmission_Absorption")[:, 0, 0]/sky.getFlux("DummyEmission")[:, 0, 0]


if __name__ == '__main__':

	rootDir = os.getcwd()
	distance = list(range(10,31))

	absorptions = [get_absorption(d) for d in distance]

	plt.plot(distance, absorptions)

	# cosmetics
	plt.grid(True)
	plt.xlabel("distance / Rsun")
	plt.ylabel("absorption")

	plt.figure()
	plt.loglog(distance, absorptions)

	# cosmetics
	plt.grid(True)
	plt.xlabel("distance / Rsun")
	plt.ylabel("absorption")

	savefigMultipage(f"distance_comp.pdf")
	plt.show()





