#ifndef CRONOS_CEXCEPTION_H
#define CRONOS_CEXCEPTION_H = 1

#include <string>
#include <exception>
using namespace std;

class CException: public std::exception
{
public:
	CException(
			string ErrorMessage,
			string Thrower = ""
			);
	CException(
			string ErrorMessage,
			int pos,
			string Thrower = ""
			);
	CException(
			string ErrorMessage,
			int q,
			int ix, int iy, int iz,
			string Thrower = ""
			);
	CException(
			string ErrorMessage,
			int pos,
			int q,
			int ix, int iy, int iz,
			string Thrower = ""
			);

	string returnError();
	string returnLocation();
	string returnThrower();

	string returnReport();

	const char* what() const noexcept;
	int type;

private:
	bool stacktrace = true;

	void finish();
	string ErrorMessage;
	string Thrower;
	string whatMessage;
	string report;
	int loc[3];
	int q;
};

#include <execinfo.h>
#include <sstream>
#include <cxxabi.h>

/** Returns the demangled stack backtrace of the caller function */
std::string get_stacktrace(unsigned int max_frames = 64);


#include <iostream>
#include <string.h>

/** Signal handler that prints a stacktrace if called */
void stacktraceHandler(int sig);

#endif
