#include "CronosTimer.H"

timeval tnow;

CronosTimer::CronosTimer()
{
	gettimeofday(&tstart, 0);
	tstop = tstart;
	totalTime = 0;
	running = false;
}

const timeval & CronosTimer::start()
{
	gettimeofday(&tstart, 0);
	tstop = tstart;
	running = true;
	return tstart;
}

const timeval & CronosTimer::stop()
{
	if(running) {
		gettimeofday(&tstop, 0);
		totalTime += diffSeconds(tstart, tstop);
		running = false;
	}
	return tstop;
}

double CronosTimer::time()
	const
{
	if (running) {
		return totalTime + dtime();
	} else {
		return totalTime;
	}
}

double CronosTimer::dtime()
	const
{
	if (running) {
		gettimeofday(&tnow, 0);
		return diffSeconds(tstart, tnow);
	} else {
		return diffSeconds(tstart, tstop);
	}
}

void CronosTimer::reset()
{
	totalTime = 0;
	running = false;
}

double CronosTimer::diffSeconds(const timeval & tstart, const timeval & tstop)
	const
{
	return ((tstop.tv_sec + tstop.tv_usec/1.e6) -(tstart.tv_sec + tstart.tv_usec/1.e6));
}

