#include "DataLink.H"

template<class T, int rank>
DataLink<T, rank>::DataLink(
		T * data,
		const int lo[rank],
		const int hi[rank]
	)
{
	this->data = data;
	size = 1;
	for (int d = 0; d < rank; d++) {
		assert(lo[d] <= hi[d]);
		this->lo[d] = lo[d];
		this->hi[d] = hi[d];
		this->dims[d] = hi[d] - lo[d] + 1;
		size *= dims[d];
	}
}

template<class T, int rank>
DataLink<T, rank>::~DataLink()
{
}

template<class T, int rank>
const int* DataLink<T, rank>::getLow() const
{
	return lo;
}

template<class T, int rank>
const int* DataLink<T, rank>::getHigh() const
{
	return hi;
}

template<class T, int rank>
const int* DataLink<T, rank>::getDims() const
{
	return dims;
}

template<class T, int rank>
int DataLink<T, rank>::getLow(int i) const
{
	return lo[i];
}

template<class T, int rank>
int DataLink<T, rank>::getHigh(int i) const
{
	return hi[i];
}

template<class T, int rank>
int DataLink<T, rank>::getDims(int i) const
{
	return dims[i];
}

template<class T, int rank>
int DataLink<T, rank>::getSize() const
{
	return size;
}



// Instantiations
#define instDataLink(T, rank) template class DataLink<T, rank>;

instDataLink(bool, 3);
instDataLink(int, 3);
instDataLink(float, 3);
instDataLink(double, 3);

#undef instDataLink
