#include "HaloBuffer.H"
#include <iostream>
#include <cmath>

REAL sqr(REAL x) { return x * x; };
REAL cube(REAL x) { return x * x * x; };

using namespace std;


// ================================================
//
//	Size tests have to be reimplemented, they
//	no longer fit the current implementation
//
// ================================================


int main() {

	//int mx[3] = { 111, 237, 573 };
	//int rim = 5;
	//int numMax = 1;
	//int deltaMax = 3;

	int mx[3] = { 10, 10, 10 };
	int rim = 3;
	int numMax = 2;
	int deltaMax = rim-1;

	SndBuffer sndBuffer(mx, rim, numMax);
	RcvBuffer rcvBuffer(mx, rim, numMax);
	int loDelta[3] = { 0, 0, 0 };
	int hiDelta[3] = { 0, 0, 0 };


/*
	//
	//	Send Buffer Max Size Tests
	//

	bool sndSizeTestSuccess = true;

	for(int shiftz=-1; shiftz <= 1; ++shiftz) {
		for(int shifty=-1; shifty <= 1; ++shifty) {
			for(int shiftx=-1; shiftx <= 1; ++shiftx) {
				int localSuccess = true;

				int isSize = sndBuffer.get_maxSize(shiftx, shifty, shiftz);

				int n1 = (1 - abs(shiftx)) * (mx[0] + deltaMax) + 1;
				int n2 = (1 - abs(shifty)) * (mx[1] + deltaMax) + 1;
				int n3 = (1 - abs(shiftz)) * (mx[2] + deltaMax) + 1;
				int n = n1 * n2 * n3;

				int shouldSize = -1;

				if (sndBuffer.is_corner(shiftx, shifty, shiftz)) {
					shouldSize = cube(rim) * numMax * n;
				} else
				if (sndBuffer.is_edge(shiftx, shifty, shiftz)) {
					shouldSize = sqr(rim) * numMax * n;
				} else
				if (sndBuffer.is_face(shiftx, shifty, shiftz)) {
					shouldSize = rim * numMax * n;
				} else
				if (shiftx == 0 && shifty == 0 && shiftz == 0) {
					shouldSize = 0;
				} else {
					localSuccess &= false;
				}

				localSuccess &= (isSize == shouldSize);
				sndSizeTestSuccess &= localSuccess;

				if (!localSuccess) {
					cerr << shiftx << ", " << shifty << ", " << shiftz << ":\t" << shouldSize << " -> " <<  isSize
						 << endl;
				}
			}
		}
	}

	cout << "Snd Max Size Test: ";
	if (sndSizeTestSuccess) {
		cout << "success" << endl;
	} else {
		cout << "failed!" << endl;
	}



	//
	//	Receive Buffer Max Size Test
	//

	bool rcvSizeTestSuccess = true;

	for(int shiftz=-1; shiftz <= 1; ++shiftz) {
		for(int shifty=-1; shifty <= 1; ++shifty) {
			for(int shiftx=-1; shiftx <= 1; ++shiftx) {
				int localSuccess = true;

				int isSize = rcvBuffer.get_maxSize(shiftx, shifty, shiftz);

				int n1 = (1 - abs(shiftx)) * (mx[0] + deltaMax) + 1;
				int n2 = (1 - abs(shifty)) * (mx[1] + deltaMax) + 1;
				int n3 = (1 - abs(shiftz)) * (mx[2] + deltaMax) + 1;
				int n = n1 * n2 * n3;

				int shouldSize = -1;

				if (rcvBuffer.is_corner(shiftx, shifty, shiftz)) {
					shouldSize = cube(rim) * numMax * n;
				} else
				if (rcvBuffer.is_edge(shiftx, shifty, shiftz)) {
					shouldSize = sqr(rim) * numMax * n;
				} else
				if (rcvBuffer.is_face(shiftx, shifty, shiftz)) {
					shouldSize = rim * numMax * n;
				} else
				if (shiftx == 0 && shifty == 0 && shiftz == 0) {
					shouldSize = 0;
				} else {
					localSuccess &= false;
				}

				localSuccess &= (isSize == shouldSize);
				rcvSizeTestSuccess &= localSuccess;

				if (!localSuccess) {
					cerr << shiftx << ", " << shifty << ", " << shiftz << ":\t" << shouldSize << " -> " <<  isSize
						 << endl;
				}
			}
		}
	}

	cout << "Rcv Max Size Test: ";
	if (rcvSizeTestSuccess) {
		cout << "success" << endl;
	} else {
		cout << "failed!" << endl;
	}



	//
	//	Compatibility Buffer Tests
	//

	bool compatTestSuccess = true;

	sndBuffer.clear();
	rcvBuffer.clear();

	sndBuffer.add_field(loDelta, hiDelta);
	rcvBuffer.add_field(loDelta, hiDelta);

	for (int shiftz = -1; shiftz <= 1; ++shiftz) {
		for (int shifty = -1; shifty <= 1; ++shifty) {
			for (int shiftx = -1; shiftx <= 1; ++shiftx) {
				int localSuccess = true;

				Buffer & snd = sndBuffer(shiftx, shifty, shiftz);
				Buffer & rcv = rcvBuffer(-shiftx, -shifty, -shiftz);

				for (int iField = 0; iField < snd.get_nFields(); ++iField) {
					for (int dim = 0; dim < 3; ++dim) {
						localSuccess &= ((snd(iField).getHigh(dim) - snd(iField).getLow(dim))
							== (rcv(iField).getHigh(dim) - rcv(iField).getLow(dim)));
					}
				}

				compatTestSuccess &= localSuccess;

				if (!localSuccess) {
					cerr << shiftx << ", " << shifty << ", " << shiftz << endl;
				}
			}
		}
	}

	cout << "Compatibility Test: ";
	if (compatTestSuccess) {
		cout << "success" << endl;
	}
	else {
		cout << "failed!" << endl;
	}
*/


	//
	//	Joined Buffer Delta Test
	//

	bool sndDeltaSizeTestSuccess = true;
	bool rcvDeltaSizeTestSuccess = true;
	bool compatDeltaTestSuccess = true;


	for (loDelta[0] = -deltaMax; loDelta[0] <= deltaMax; ++loDelta[0]) {
	for (loDelta[1] = -deltaMax; loDelta[1] <= deltaMax; ++loDelta[1]) {
	for (loDelta[2] = -deltaMax; loDelta[2] <= deltaMax; ++loDelta[2]) {

		for (hiDelta[0] = -deltaMax; hiDelta[0] <= deltaMax; ++hiDelta[0]) {
		for (hiDelta[1] = -deltaMax; hiDelta[1] <= deltaMax; ++hiDelta[1]) {
		for (hiDelta[2] = -deltaMax; hiDelta[2] <= deltaMax; ++hiDelta[2]) {

			sndBuffer.clear();
			rcvBuffer.clear();

			for (int nFields = 1; nFields < numMax; ++nFields) {

				// Add fields
				for (int iField = 0; iField < nFields; ++iField) {
					sndBuffer.add_field(loDelta, hiDelta);
					rcvBuffer.add_field(loDelta, hiDelta);
				}

				/*
				//
				//	Send Buffer Delta Size Test
				//
				for (int shiftz = -1; shiftz <= 1; ++shiftz) {
				for (int shifty = -1; shifty <= 1; ++shifty) {
				for (int shiftx = -1; shiftx <= 1; ++shiftx) {

					int localSuccess = true;
					int isSize = sndBuffer.get_size(shiftx, shifty, shiftz);

					int n1 = (1 - abs(shiftx)) * (mx[0] + (hiDelta[0] - loDelta[0])) + 1;
					int n2 = (1 - abs(shifty)) * (mx[1] + (hiDelta[1] - loDelta[1])) + 1;
					int n3 = (1 - abs(shiftz)) * (mx[2] + (hiDelta[2] - loDelta[2])) + 1;
					int n = n1 * n2 * n3;

					int shouldSize = -1;

					if (sndBuffer.is_corner(shiftx, shifty, shiftz)) {
						shouldSize = cube(rim) * nFields * n;
					} else
					if (sndBuffer.is_edge(shiftx, shifty, shiftz)) {
						shouldSize = sqr(rim) * nFields * n;
					} else
					if (sndBuffer.is_face(shiftx, shifty, shiftz)) {
						shouldSize = rim * nFields * n;
					} else
					if (shiftx == 0 && shifty == 0 && shiftz == 0) {
						shouldSize = 0;
					} else {
						localSuccess &= false;
					}

					localSuccess &= (isSize == shouldSize);
					sndDeltaSizeTestSuccess &= localSuccess;

					if (!localSuccess) {
						cerr << " sndBuff Delta "
							 << shiftx << ", " << shifty << ", " << shiftz << ":\t" << shouldSize << " -> " <<  isSize
							 << endl;
					}
				}
				}
				}



				//
				//	Receive Buffer Delta Size Test
				//
				for (int shiftz = -1; shiftz <= 1; ++shiftz) {
				for (int shifty = -1; shifty <= 1; ++shifty) {
				for (int shiftx = -1; shiftx <= 1; ++shiftx) {

					int localSuccess = true;
					int isSize = rcvBuffer.get_size(shiftx, shifty, shiftz);

					int n1 = (1 - abs(shiftx)) * (mx[0] + (hiDelta[0] - loDelta[0])) + 1;
					int n2 = (1 - abs(shifty)) * (mx[1] + (hiDelta[1] - loDelta[1])) + 1;
					int n3 = (1 - abs(shiftz)) * (mx[2] + (hiDelta[2] - loDelta[2])) + 1;
					int n = n1 * n2 * n3;

					int shouldSize = -1;

					if (rcvBuffer.is_corner(shiftx, shifty, shiftz)) {
						shouldSize = cube(rim) * nFields * n;
					} else
					if (rcvBuffer.is_edge(shiftx, shifty, shiftz)) {
						shouldSize = sqr(rim) * nFields * n;
					} else
					if (rcvBuffer.is_face(shiftx, shifty, shiftz)) {
						shouldSize = rim * nFields * n;
					} else
					if (shiftx == 0 && shifty == 0 && shiftz == 0) {
						shouldSize = 0;
					} else {
						localSuccess &= false;
					}

					localSuccess &= (isSize == shouldSize);
					rcvDeltaSizeTestSuccess &= localSuccess;

					if (!localSuccess) {
						cerr << " rcvBuff Delta"
							 << shiftx << ", " << shifty << ", " << shiftz << ":\t" << shouldSize << " -> " << isSize
							 << endl;
					}
				}
				}
				}
				*/


				//
				//	Compatibility Buffer Tests
				//

				for (int shiftz = -1; shiftz <= 1; ++shiftz) {
				for (int shifty = -1; shifty <= 1; ++shifty) {
				for (int shiftx = -1; shiftx <= 1; ++shiftx) {
					if ((shiftx == 0) && (shifty == 0) && (shiftz == 0)) continue;

					int localSuccess = true;

					Buffer & snd = sndBuffer(shiftx, shifty, shiftz);
					Buffer & rcv = rcvBuffer(-shiftx, -shifty, -shiftz);

					for (int iField = 0; iField < snd.get_nFields(); ++iField) {
						for (int dim = 0; dim < 3; ++dim) {
							localSuccess &= ((snd(iField).getHigh(dim) - snd(iField).getLow(dim))
								== (rcv(iField).getHigh(dim) - rcv(iField).getLow(dim)));
						}
					}

					compatDeltaTestSuccess &= localSuccess;

					if (!localSuccess) {
						cerr << " compat Delta ";
						cerr << shiftx << ", " << shifty << ", " << shiftz;
						cerr << " loDelta " << loDelta[0] << " " << loDelta[1] << " " << loDelta[2];
						cerr << " hiDelta " << hiDelta[0] << " " << hiDelta[1] << " " << hiDelta[2];
						cerr << endl;

						for (int iField = 0; iField < snd.get_nFields(); ++iField) {
							cerr << "     Field " << iField << ": ";
							for (int dim = 0; dim < 3; ++dim) {
								cerr << snd(iField).getHigh(dim) - snd(iField).getLow(dim) << " ";
							}
							cerr << " -> ";
							for (int dim = 0; dim < 3; ++dim) {
								cerr << rcv(iField).getHigh(dim) - rcv(iField).getLow(dim) << " ";
							}
							cerr << endl;
						}
						exit(1);
					}
				}
				}
				}

			} // nFields
		} // HIGHs
		}
		}
	} // LOWs
	}
	}
/*
	cout << "Snd Delta Size Test: ";
	if (sndDeltaSizeTestSuccess) {
		cout << "success" << endl;
	}
	else {
		cout << "failed!" << endl;
	}

	cout << "Rcv Delta Size Test: ";
	if (rcvDeltaSizeTestSuccess) {
		cout << "success" << endl;
	}
	else {
		cout << "failed!" << endl;
	}
*/

	cout << "Compatibility Delta Test: ";
	if (compatDeltaTestSuccess) {
		cout << "success" << endl;
	}
	else {
		cout << "failed!" << endl;
	}




}
