#include "units.H"
#include "physical_constants.H"
#include "normalisation.H"


using namespace CRONOS_CONSTANTS;

class TestNorm : public normalisation {
public:
	virtual void setup();
};

void TestNorm::setup() {

	set_definition(LEN, AstronomicalUnit);
	set_definition(MASS, 1 * KiloGram);
	set_definition(VEL, SpeedOfLight);
	set_definition(TEMP);
	set_definition(MAG_IND, Tesla);
	set_definition(NUM_DENS);

	finish_setup();
}


int main() {

	TestNorm norm;
	norm.setup();
	norm.print_norms(std::cout);

	std::cout << GravitationalConstant << std::endl;
	std::cout << norm.get_num(GravitationalConstant) << std::endl;
	std::cout << norm.get_num(AstronomicalUnit) << std::endl;
	std::cout << norm.get_num(Tesla) << std::endl;

//	std::cout << norm.get_const(TestNorm.E_DENS) << std::endl;
//	std::cout << norm.get_const(TestNorm.PRESS) << std::endl;


	NormSound normSound;
	normSound.setup();
	normSound.print_norms(std::cout);

	std::cout << normSound.normQuantity(normSound.PRESS) << std::endl;
	std::cout << normSound.get_num(normSound.normQuantity(normSound.PRESS)) << std::endl;




	NormMagInd normMag;
	normMag.setup();
	normMag.print_norms(std::cout);

	std::cout << normMag.normQuantity(normMag.PRESS) << std::endl;
	std::cout << normMag.get_num(normMag.normQuantity(normMag.PRESS)) << std::endl;




}
